SystemOrganization addCategory: #'SOUL-NativeClauses'!

ResolvableTerm subclass: #NativeClause
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

NativeClause subclass: #AndClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!AndClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv startAt: anIndex
	"resolve an and-clause by fetching the conditions from the clause and  
	putting them all back on the stack"

	
	| args resolveBlock clausesPointer clauses |
	clausesPointer := self getArgument: 1 in: anEnv startAt: anIndex.
	clauses := OrderedCollection new.
	clausesPointer term listDo: [:aClause | clauses add: aClause].
	args := OrderedCollection new.
	args add: clauses.
	resolveBlock := [:myClauses | 
	ResolutionResult
		condition: myClauses
		rollbackInfo: anEnv rollbackInfo
		conditionsEnvIndex: clausesPointer envIndex
		cutState: false].
	^NativeResolver onBlock: resolveBlock withArguments: args! !

NativeClause subclass: #ClauseClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!ClauseClause methodsFor: 'resolving' stamp: 'AndyKellens 11/2/2011 09:53'!
resolveIn: anEnv startAt: envIndex
	
	| headPointer bodyPointer head body clauses address clausePointer |
	headPointer := self getArgument: 1 in: anEnv startAt: envIndex.
	bodyPointer := self getArgument: 2 in: anEnv startAt: envIndex.
	clausePointer := self getArgument: 3 in: anEnv startAt: envIndex.
	headPointer term innerTerm isVariable
		ifTrue:
			[clauses := OrderedCollection new.
			self definitionRepository clausesDo: [:clause | clauses add: clause]]
		ifFalse:
			[(headPointer term innerTerm
				predicateInEnv: anEnv
				startAt: headPointer envIndex) == nil
				ifTrue:
					[clauses := self definitionRepository
						allClausesWith: headPointer term innerTerm multiplicity]
				ifFalse:
					[address := self definitionRepository
						addressForPredicate:
							(headPointer term innerTerm
								predicateInEnv: anEnv
								startAt: headPointer envIndex).
					address isNil
						ifTrue: [clauses := OrderedCollection new]
						ifFalse:
							[clauses := self definitionRepository
								normalAddressLookup: address
								multiplicity: headPointer term innerTerm multiplicity]]].
	clauses isEmpty
		ifTrue:
			[clauses add: nil.
			^NativeResolver
				onBlock: [:theNil | theNil]
				withArguments: clauses]
		ifFalse:
			[^NativeResolver
				onBlock:
					[:clause | 
					| hisIndex |
					head := clause conclusion.
					body := SoulFactory current makeList termSequence: clause condition.
					hisIndex := anEnv startUnifyWith: clause.
					(headPointer term
						unifyWith: head
						inEnv: anEnv
						myIndex: headPointer envIndex
						hisIndex: hisIndex
						inSource: true)
						&
							(bodyPointer term
								unifyWith: body
								inEnv: anEnv
								myIndex: bodyPointer envIndex
								hisIndex: hisIndex
								inSource: true)
						&
							(clausePointer term
								unifyWith: (UppedObject up: clause)
								inEnv: anEnv
								myIndex: clausePointer envIndex
								hisIndex: hisIndex
								inSource: true)
						ifTrue:
							[ResolutionResult
								condition: OrderedCollection new
								rollbackInfo: anEnv rollbackInfo
								conditionsEnvIndex: hisIndex
								cutState: false]
						ifFalse:
							[anEnv rollback.
							nil]]
				withArguments: clauses]! !

NativeClause subclass: #EnvLookupClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!EnvLookupClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv startAt: anIndex
	
	| args termpointer resultpointer |
	termpointer := self getArgument: 1 in: anEnv startAt: anIndex.
	resultpointer := self getArgument: 2 in: anEnv startAt: anIndex.
	args := OrderedCollection new.
	args add: termpointer.
	^NativeResolver
		onBlock:
			[:theArg | 
			| hisIndex |
			hisIndex := anEnv startUnify: 0.
			(resultpointer term
				unifyWith: termpointer soulUp
				inEnv: anEnv
				myIndex: resultpointer envIndex
				hisIndex: hisIndex
				inSource: true)
				ifTrue:
					[ResolutionResult
						condition: OrderedCollection new
						rollbackInfo: anEnv rollbackInfo
						conditionsEnvIndex: hisIndex
						cutState: false]
				ifFalse:
					[anEnv rollback.
					nil]]
		withArguments: args! !

NativeClause subclass: #GetEnvClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!GetEnvClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv startAt: anIndex
	
	| argument1 argument2 |
	argument1 := self getArgument: 1 in: anEnv startAt: anIndex.
	argument2 := self getArgument: 2 in: anEnv startAt: anIndex.
	^NativeResolver
		onBlock:
			[:theArg | 
			| hisIndex |
			hisIndex := anEnv startUnify: 0.
			(argument1 term
				unifyWith: anEnv soulUp
				inEnv: anEnv
				myIndex: argument1 envIndex
				hisIndex: hisIndex
				inSource: true)
				ifTrue:
					[(argument2 term
						unifyWith: (anIndex - 2) soulUp
						inEnv: anEnv
						myIndex: argument2 envIndex
						hisIndex: hisIndex
						inSource: true)
						ifTrue:
							[ResolutionResult
								condition: OrderedCollection new
								rollbackInfo: anEnv rollbackInfo
								conditionsEnvIndex: hisIndex
								cutState: false]
						ifFalse:
							[anEnv rollback.
							nil]	"because getEnv itself reserves 2 spaces on the stack, we need to decrement by 2 to get the index before getEnv"
]
				ifFalse:
					[anEnv rollback.
					nil]]
		withArguments: #(#foo)! !

NativeClause subclass: #GetRepositoryClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!GetRepositoryClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv startAt: anIndex
	
	| argument args |
	argument := self getArgument: 1 in: anEnv startAt: anIndex.
	args := OrderedCollection new.
	args add: argument.
	^NativeResolver
		onBlock:
			[:theArg | 
			| hisIndex |
			hisIndex := anEnv startUnify: 0.
			(theArg term
				unifyWith: self definitionRepository soulUp
				inEnv: anEnv
				myIndex: theArg envIndex
				hisIndex: hisIndex
				inSource: true)
				ifTrue:
					[ResolutionResult
						condition: OrderedCollection new
						rollbackInfo: anEnv rollbackInfo
						conditionsEnvIndex: hisIndex
						cutState: false]
				ifFalse:
					[anEnv rollback.
					nil]]
		withArguments: args! !

!NativeClause class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
newWith: header
	
	^super new initializeWith: header! !

!NativeClause methodsFor: 'visitor' stamp: 'sp 24/10/11 15:26'!
accept: aVisitor
	
	^aVisitor nativeClauseVisit: self! !

!NativeClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
getArgument: aNumber in: anEnv startAt: anIndex
	
	| result |
	result := anEnv
		lookup: (header terms at: aNumber)
		startAt: anIndex.
	^result
		ifNil:
			[TermPointer
				term: (header terms at: aNumber)
				envIndex: anIndex]
		ifNotNil: [result]! !

!NativeClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
header
	
	^header! !

!NativeClause methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
initializeWith: head
	
	header := head! !

!NativeClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isNative
	
	^true! !

!NativeClause methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream write: '***native clause***'! !

!NativeClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv startAt: anIndex
	
	self error: 'Nativeclause has no #resolveIn:startAt: defined!!'! !

!NativeClause methodsFor: 'reification' stamp: 'sp 24/10/11 15:26'!
transitiveLookupIn: anEnv startAt: anIndex
	
	^self! !

!NativeClause methodsFor: 'unification' stamp: 'sp 24/10/11 15:26'!
unifyWith: aTerm inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	^aTerm
		unifyWithNativeClause: self
		inEnv: anEnv
		myIndex: targetIndex
		hisIndex: sourceIndex
		inSource: (inSource xor: true)! !

!NativeClause methodsFor: 'unification' stamp: 'sp 24/10/11 15:26'!
unifyWithVariable: aVariable inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	^aVariable
		unifyWithNativeClause: self
		inEnv: anEnv
		myIndex: targetIndex
		hisIndex: sourceIndex
		inSource: (inSource xor: true)! !

NativeClause subclass: #NotClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!NotClause class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
clauses: aCollection
	
	^self new setClauses: aCollection containsCut: false! !

!NotClause methodsFor: 'resolving' stamp: 'AndyKellens 11/2/2011 09:53'!
resolveIn: anEnv startAt: anIndex
	
	| query ruleSelector args resolveBlock theNil holdCallStack clausesPointer clauses |
	args := OrderedCollection new.
	clausesPointer := self getArgument: 1 in: anEnv startAt: anIndex.
	clauses := OrderedCollection new.
	clausesPointer term listDo: [:anItem | clauses add: anItem].
	query := SoulFactory current makeQuery
		condition: 
			((SoulFactory current makeTermSequence terms: clauses)
				definitionRepository: self definitionRepository).
	ruleSelector := SoulFactory current makeRuleSelector new.
	holdCallStack := anEnv callStack.
	ruleSelector
		evalQuery: query
		inEnv: anEnv
		startAt: clausesPointer envIndex.
	args add: ruleSelector next.
	anEnv callStack: holdCallStack.
	theNil := nil.
	resolveBlock := [:theResult | 
	theResult == false
		ifTrue:
			[ResolutionResult
				condition:
					(SoulFactory current makeTermSequence terms: OrderedCollection new)
				rollbackInfo: anEnv rollbackInfo
				conditionsEnvIndex: anEnv currentVariableIndex
				cutState: false]
		ifFalse: [theNil]].
	^NativeResolver onBlock: resolveBlock withArguments: args! !

NativeClause subclass: #OrClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!OrClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv startAt: anIndex
	"Need to put them in a collection because the expandStack method wants  
	to do a reverseDo on every clause(Sequence)"

	
	| resolveBlock ownClauses clausesPointer |
	clausesPointer := self getArgument: 1 in: anEnv startAt: anIndex.
	resolveBlock := [:clause | 
	| temp |
	temp := OrderedCollection new.
	temp add: clause.
	ResolutionResult
		condition: temp
		rollbackInfo: anEnv rollbackInfo
		conditionsEnvIndex: clausesPointer envIndex
		cutState: false].
	ownClauses := OrderedCollection new.
	clausesPointer term listDo: [:aClause | ownClauses add: aClause].
	^NativeResolver onBlock: resolveBlock withArguments: ownClauses! !

NativeClause subclass: #SLGClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!SLGClause methodsFor: 'resolving' stamp: 'AndyKellens 11/2/2011 09:53'!
resolveIn: anEnv startAt: anIndex
	
	| query ruleSelector args resolveBlock theNil holdCallStack callTerm theCall |
	"Not working yet!!"

	args := OrderedCollection new.
	callTerm := self getArgument: 1 in: anEnv startAt: anIndex.
	theCall := self callForCallTerm: callTerm term.
	theCall evaluate.
	query := (SoulFactory current makeQuery
		condition:
			(SoulFactory current makeCompound
				functor: (Constant name: 'slg' , callTerm term functor name)
				termSequence:
					(SoulFactory current makeTermSequence
						terms: callTerm term terms , (UppedObject up: theCall id))))
		definitionRepository: self definitionRepository.
	ruleSelector := SoulFactory current makeRuleSelector new.
	holdCallStack := anEnv callStack.
	ruleSelector
		evalQuery: query
		inEnv: anEnv
		startAt: callTerm envIndex.
	args add: ruleSelector next.
	anEnv callStack: holdCallStack.
	theNil := nil.
	resolveBlock := [:theResult | 
	theResult == false
		ifTrue:
			[ResolutionResult
				condition:
					(SoulFactory current makeTermSequence terms: OrderedCollection new)
				rollbackInfo: anEnv rollbackInfo
				conditionsEnvIndex: anEnv currentVariableIndex
				cutState: false]
		ifFalse: [theNil]].
	^NativeResolver
		onBlock: resolveBlock
		withArguments: theCall answers! !

NativeClause subclass: #SetResolverClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!SetResolverClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
argsIn: anEnv startAt: anIndex
	
	^(header terms at: 2) soulDownIn: anEnv startAt: anIndex! !

!SetResolverClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
blockIn: anEnv startAt: anIndex
	
	^header terms first soulDownIn: anEnv startAt: anIndex! !

!SetResolverClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: env startAt: anIndex
	
	| args block |
	block := self blockIn: env startAt: anIndex.
	args := self argsIn: env startAt: anIndex.
	^NativeResolver onBlock: block withArguments: args! !

NativeClause subclass: #WriteToPrologClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-NativeClauses'!

!WriteToPrologClause methodsFor: 'resolving' stamp: 'AndyKellens 11/2/2011 09:53'!
resolveIn: anEnv startAt: anIndex
	
	| argument writestream |
	argument := self getArgument: 1 in: anEnv startAt: anIndex.
	^NativeResolver
		onBlock:
			[:args | 
			writestream := WriteStream on: String new.
			argument term
				printAsPrologOn: writestream
				scope: #asTerm
				in: anEnv
				startAt: argument envIndex.
			Transcript
				show: writestream contents;
				cr.
			ResolutionResult
				condition:
					(SoulFactory current makeTermSequence terms: OrderedCollection new)
				rollbackInfo: anEnv rollbackInfo
				conditionsEnvIndex: anEnv currentVariableIndex
				cutState: false]
		withArguments: #(#foo)! !
